echo " " | awk '

BEGIN {
  PI         = 3.141592654;
  DEGTOPI    = PI / 180.0;
  iNrOfSteps = 300;
  iWidth     = 720;
  iHeight    = 480;
}

  function createCircle(radius)
  {
    rr = radius * radius;
    for(t=0;t<iNrOfSteps;t++)  {
      # full circle == 2*PI
      alpha = t / iNrOfSteps * 2.0 * PI;
      x = radius * sin ( alpha );
      y = sqrt ( rr - x * x );

      X[t] = x;
      Y[t] = y;
      Z[t] = 0.0;
      if ( ( alpha > 0.5 * PI ) && ( alpha < 1.5 * PI ) )  {
        Y[t] = -y;
      }
      # printf ( "%d %d\n", X[t] + 420, Y[t] + 220 );
    }
  };

  function rotateX(angle)
  {
    a = angle * DEGTOPI;
    for (t=0;t<iNrOfSteps;t++)  {
      Y[t] = cos(a) * Y[t] - sin(a) * Z[t];
      Z[t] = sin(a) * Y[t] + cos(a) * Z[t];
    }
  };

  function rotateY(angle)
  {
    a = angle * DEGTOPI;
    for (t=0;t<iNrOfSteps;t++)  {
      X[t] = cos(a) * X[t] + sin(a) * Z[t];
      Z[t] =-sin(a) * X[t] + cos(a) * Z[t];
    }
  };

  function rotateZ(angle)
  {
    a = angle * DEGTOPI;
    for (t=0;t<iNrOfSteps;t++)  {
      X[t] = cos(a) * X[t] - sin(a) * Y[t];
      Y[t] = sin(a) * X[t] + cos(a) * Y[t];
    }
  };

 END {

  # First we create a centered circle with set radius
  createCircle(400);
  # Next we rotate the circle around the X-Axis ( make a Ellipse out of it)
  rotateX(  75.0 );
  # and we also rotate around the Z-Axis
  rotateZ(  50.0 );
  rotateY( -30.0 );

  # Lastly we print the valus to stdout
  for(t=0;t<iNrOfSteps;t++)  {
     iZIndex = t + 75;
     if ( iZIndex >= iNrOfSteps )
       iZIndex -= iNrOfSteps;
    if ( ( t > 119 ) && ( t < 194 ) )
      printf ( "0 0 0.0\n" );
    else
       printf ( "%d %d %f\n", X[t] + 422, Y[t] + 230, (Z[iZIndex]+115.0)/230.0 * 0.7);
#       printf ( "%d %d %f\n", X[t] + 422, Y[t] + 230, (Z[iZIndex]+115.0)/230.0 );
  }


 # printf ( "Array[0]=%f Array[0]=%f Array[1]=%f Array[1]=%f\n", arrayValuesX[0],  arrayValuesY[0],  arrayValuesX[1], arrayValuesY[1] );

}'

